/*
 * soft.h
 * Soft instruction prototypes.
 *
 * Copyright (c) 1996 Systems Architecture Research Centre,
 *                 City University, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@sarc.city.ac.uk>, May 1996.
 */

#ifndef __soft_h
#define	__soft_h

struct _methodTable;
struct _strpair;
struct _classes;
struct _object;

void* soft_new(struct _classes*);
void* soft_anewarray(struct _classes*, jint);
void* soft_newarray(jint, jint);
void* soft_multianewarray(struct _classes*, jint, slots*);

void soft_monitorenter(struct _object*);
void soft_monitorexit(struct _object*);

void* soft_lookupmethod(struct _methodTable*, struct _strpair*);
void soft_checkcast(struct _classes*, struct _object*);
jint soft_instanceof(struct _classes*, struct _object*);

void soft_athrow(struct _object*);
void soft_badarrayindex(void);

jint soft_dcmpg(double, double);
jint soft_dcmpl(double, double);
jint soft_fcmpg(float, float);
jint soft_fcmpl(float, float);

#endif
