/*
 * locks.h
 * Manage locking system
 * This include the mutex's and cv's.
 *
 * Copyright (c) 1996 Systems Architecture Research Centre,
 *		   City University, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@sarc.city.ac.uk>, February 1996.
 */

#ifndef __locks_h
#define __locks_h

void lockMutex(struct _object*);
void unlockMutex(struct _object*);
void waitCond(struct _object*, int64);
void signalCond(struct _object*);
void broadcastCond(struct _object*);

#if defined(HAVE_NATIVE_INT64)
#define WAITFOREVER     -1LL
#else
#define WAITFOREVER     (*(int64*)0)
#endif

#endif
